from django.contrib import admin
import pendulum

from .models import Bill
from.tasks import get_overdue_bills

@admin.action(description='Duplicate Bill')
def duplicate(modeladmin, request, queryset):
        for object in queryset:
            object.id = None
            # object.name = object.name+'-duplicate' ## This was temporary while I figured out how to massage the date
            # print(object.due)
            new_date = (pendulum.parse(str(object.due), exact=True)).add(months=1)
            # print(new_date)
            object.due = new_date
            object.save()

@admin.action(description='Duplicate Older Bill')
def duplicate_old(modeladmin, request, queryset):
        for object in queryset:
            object.id = None
            new_date = (pendulum.parse(str(object.due), exact=True)).subtract(months=1)
            object.due = new_date
            object.save()

@admin.register(Bill)
class BillAdmin(admin.ModelAdmin):
    list_display = ['name', 'due', 'amount']
    list_filter = ('name', 'type', 'is_paid', 'is_overdue', 'is_missed')
    search_fields = ['name', 'type', 'amount'
    ]
    actions = [duplicate, duplicate_old, get_overdue_bills]